import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int sum = 0;
        int[][] nm = new int[n][6];
        for (int i = 0; i < n; i++) {
            String as = br.readLine();
            for (int k = 0; k < 6; k++) {
                if (as.charAt(k) == 'X') {
                    nm[i][k] = 1;
                    sum++;
                }
            }
        }
        if ((sum + m) % 2 != 0) {
            out.println("Impossible");
            out.close();
            return;
        } else if (sum + m > n * 6) {
            out.println("Impossible");
            out.close();
            return;
        } else {
            for (int i = 0; i < n; i++) {
                for (int k = 0; k < 3; k++) {
                    if (nm[i][k] == 1 && nm[i][Math.abs(k - 5)] == 0) {
                        nm[i][Math.abs(k - 5)] = 1;
                        m--;
                        if (m < 0) {
                            out.println("Impossible");
                            out.close();
                            return;
                        }
                    } else if (nm[i][k] == 0 && nm[i][Math.abs(k - 5)] == 1) {
                        nm[i][Math.abs(k)] = 1;
                        m--;
                        if (m < 0) {
                            out.println("Impossible");
                            out.close();
                            return;
                        }
                    }

                }
            }
        }
        if (m > 0) {
            for (int i = 0; i < n; i++) {
                for (int k = 0; k < 3; k++) {
                    if (nm[i][k] == 0 && nm[i][Math.abs(k - 5)] == 0) {
                        nm[i][k] = 1;
                        nm[i][Math.abs(k - 5)] = 1;
                        m -= 2;
                        if (m == 0) {
                            for (int z = 0; z < n; z++) {
                                for (int kx = 0; kx < 6; kx++) {
                                    if (nm[z][kx] == 1) {
                                        out.print('X');
                                    } else {
                                        out.print('.');
                                    }
                                }
                                out.println("");
                            }
                            out.close();
                            return;
                        }
                    }

                }
            }
        } else {
            for (int i = 0; i < n; i++) {
                for (int k = 0; k < 6; k++) {
                    if (nm[i][k] == 1) {
                        out.print('X');
                    } else {
                        out.print('.');
                    }
                }
                out.println("");
            }
        }


        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}